import { Change, CloudFunction } from 'firebase-functions';
import { DocumentSnapshot } from 'firebase-functions/lib/v1/providers/firestore';
import { Config, Rule } from '../common';
export interface MaintainCountRule {
    rule: 'MAINTAIN_COUNT';
    name?: string;
    source: {
        collection: string;
        foreignKey: string;
    };
    target: {
        collection: string;
        attribute: string;
    };
}
export declare function isMaintainCountRule(arg: Rule): arg is MaintainCountRule;
export declare type MaintainCountFunction = CloudFunction<Change<DocumentSnapshot>>;
export declare function integrifyMaintainCount(rule: MaintainCountRule, config: Config): MaintainCountFunction;
